/* Watcher.rexx - Creates a watcher to count and resume any execution breakpoint
 *
 * $VER: JoyFury.rexx 1.1 (22.02.15)  2015 by Philippe 'OffseT' Rimauro <offset@cpcscene.net>
 * Requires ACE 1.6 or later
 */

OPTIONS RESULTS
PARSE ARG port

SIGNAL ON BREAK_C

IF ~SHOW('P',port) THEN EXIT

ADDRESS(port)

"GETLASTBREAKTYPE"; breakpoints = RESULT
PARSE VAR breakpoints "["execution"]["dummy

IF execution = "Execution" THEN DO
    IF OPEN(handler,"ENV:ACE_Watcher","r")~=0 THEN DO
        count=READLN(handler)+1
        CLOSE(handler)
    END
    ELSE DO
        count=1
    END

    IF OPEN(handler,"ENV:ACE_Watcher","w")~=0 THEN DO
        WRITELN(handler,count)
        CLOSE(handler)
    END

    "START"
END

EXIT
